git-am.sh 11.2 KB
Newer Older
1 2
#!/bin/sh
#
3
# Copyright (c) 2005, 2006 Junio C Hamano
4

5
SUBDIRECTORY_OK=Yes
6 7 8 9 10 11 12
OPTIONS_KEEPDASHDASH=
OPTIONS_SPEC="\
git-am [options] <mbox>|<Maildir>...
git-am [options] --resolved
git-am [options] --skip
--
d,dotest=       use <dir> and not .dotest
13
i,interactive   run interactively
14 15 16 17
b,binary        pass --allo-binary-replacement to git-apply
3,3way          allow fall back on 3way merging if needed
s,signoff       add a Signed-off-by line to the commit message
u,utf8          recode into utf8 (default)
18
k,keep          pass -k flag to git-mailinfo
19 20 21 22 23 24 25
whitespace=     pass it through git-apply
C=              pass it through git-apply
p=              pass it through git-apply
resolvemsg=     override error message when patch failure occurs
r,resolved      to be used after a patch failure
skip            skip the current patch"

26
. git-sh-setup
27
set_reflog_action am
28
require_work_tree
29
cd_to_toplevel
30

31 32
git var GIT_COMMITTER_IDENT >/dev/null || exit

33 34 35 36 37
stop_here () {
    echo "$1" >"$dotest/next"
    exit 1
}

38
stop_here_user_resolve () {
39
    if [ -n "$resolvemsg" ]; then
J
Jeff King 已提交
40
	    printf '%s\n' "$resolvemsg"
41 42
	    stop_here $1
    fi
43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61
    cmdline=$(basename $0)
    if test '' != "$interactive"
    then
        cmdline="$cmdline -i"
    fi
    if test '' != "$threeway"
    then
        cmdline="$cmdline -3"
    fi
    if test '.dotest' != "$dotest"
    then
        cmdline="$cmdline -d=$dotest"
    fi
    echo "When you have resolved this problem run \"$cmdline --resolved\"."
    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."

    stop_here $1
}

62 63 64 65 66 67 68
go_next () {
	rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
		"$dotest/patch" "$dotest/info"
	echo "$next" >"$dotest/next"
	this=$next
}

69 70 71 72 73 74
cannot_fallback () {
	echo "$1"
	echo "Cannot fall back to three-way merge."
	exit 1
}

75 76 77 78 79 80 81
fall_back_3way () {
    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`

    rm -fr "$dotest"/patch-merge-*
    mkdir "$dotest/patch-merge-tmp-dir"

    # First see if the patch records the index info that we can use.
82 83
    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
	"$dotest/patch" &&
84
    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
85
    git write-tree >"$dotest/patch-merge-base+" ||
86
    cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
87 88 89

    echo Using index info to reconstruct a base tree...
    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
90
	git apply $binary --cached <"$dotest/patch"
91 92 93
    then
	mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
	mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
94 95 96
    else
        cannot_fallback "Did you hand edit your patch?
It does not apply to blobs recorded in its index."
97 98 99
    fi

    test -f "$dotest/patch-merge-index" &&
100
    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
101 102 103 104 105 106 107 108
    orig_tree=$(cat "$dotest/patch-merge-base") &&
    rm -fr "$dotest"/patch-merge-* || exit 1

    echo Falling back to patching base and 3-way merge...

    # This is not so wrong.  Depending on which base we picked,
    # orig_tree may be wildly different from ours, but his_tree
    # has the same set of wildly different changes in parts the
109
    # patch did not touch, so recursive ends up canceling them,
110 111
    # saying that we reverted all those changes.

112 113 114
    eval GITHEAD_$his_tree='"$SUBJECT"'
    export GITHEAD_$his_tree
    git-merge-recursive $orig_tree -- HEAD $his_tree || {
115
	    git rerere
116 117 118
	    echo Failed to merge in the changes.
	    exit 1
    }
119
    unset GITHEAD_$his_tree
120 121
}

J
Junio C Hamano 已提交
122 123 124 125
reread_subject () {
	git stripspace <"$1" | sed -e 1q
}

126
prec=4
127 128
dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
resolvemsg= resume=
M
Michael S. Tsirkin 已提交
129
git_apply_opt=
130

131
while test $# != 0
132 133
do
	case "$1" in
134 135 136 137 138 139
	-i|--interactive)
		interactive=t ;;
	-b|--binary)
		binary=t ;;
	-3|--3way)
		threeway=t ;;
140
	-s|--signoff)
141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159
		sign=t ;;
	-u|--utf8)
		utf8=t ;; # this is now default
	--no-utf8)
		utf8= ;;
	-k|--keep)
		keep=t ;;
	-r|--resolved)
		resolved=t ;;
	--skip)
		skip=t ;;
	-d|--dotest)
		shift; dotest=$1;;
	--resolvemsg)
		shift; resolvemsg=$1 ;;
	--whitespace)
		git_apply_opt="$git_apply_opt $1=$2"; shift ;;
	-C|-p)
		git_apply_opt="$git_apply_opt $1$2"; shift ;;
160
	--)
161
		shift; break ;;
162
	*)
163
		usage ;;
164
	esac
165
	shift
166 167
done

J
Junio C Hamano 已提交
168 169
# If the dotest directory exists, but we have finished applying all the
# patches in them, clear it out.
170 171 172 173 174 175 176 177 178 179 180
if test -d "$dotest" &&
   last=$(cat "$dotest/last") &&
   next=$(cat "$dotest/next") &&
   test $# != 0 &&
   test "$next" -gt "$last"
then
   rm -fr "$dotest"
fi

if test -d "$dotest"
then
J
Junio C Hamano 已提交
181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199
	case "$#,$skip$resolved" in
	0,*t*)
		# Explicit resume command and we do not have file, so
		# we are happy.
		: ;;
	0,)
		# No file input but without resume parameters; catch
		# user error to feed us a patch from standard input
		# when there is already .dotest.  This is somewhat
		# unreliable -- stdin could be /dev/null for example
		# and the caller did not intend to feed us a patch but
		# wanted to continue unattended.
		tty -s
		;;
	*)
		false
		;;
	esac ||
	die "previous dotest directory $dotest still exists but mbox given."
200
	resume=yes
201
else
J
Junio C Hamano 已提交
202 203
	# Make sure we are not given --skip nor --resolved
	test ",$skip,$resolved," = ,,, ||
204
		die "Resolve operation not in progress, we are not resuming."
205 206 207 208

	# Start afresh.
	mkdir -p "$dotest" || exit

209
	git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
210 211 212 213
		rm -fr "$dotest"
		exit 1
	}

J
Junio C Hamano 已提交
214 215
	# -b, -s, -u, -k and --whitespace flags are kept for the
	# resuming session after a patch failure.
J
Junio C Hamano 已提交
216
	# -3 and -i can and must be given when resuming.
217
	echo "$binary" >"$dotest/binary"
J
Junio C Hamano 已提交
218
	echo " $ws" >"$dotest/whitespace"
219 220 221 222 223 224
	echo "$sign" >"$dotest/sign"
	echo "$utf8" >"$dotest/utf8"
	echo "$keep" >"$dotest/keep"
	echo 1 >"$dotest/next"
fi

J
Junio C Hamano 已提交
225 226
case "$resolved" in
'')
227
	files=$(git diff-index --cached --name-only HEAD --) || exit
J
Junio C Hamano 已提交
228 229 230 231 232 233
	if [ "$files" ]; then
	   echo "Dirty index: cannot apply patches (dirty: $files)" >&2
	   exit 1
	fi
esac

234 235 236 237
if test "$(cat "$dotest/binary")" = t
then
	binary=--allow-binary-replacement
fi
238 239 240
if test "$(cat "$dotest/utf8")" = t
then
	utf8=-u
241 242
else
	utf8=-n
243 244 245 246 247
fi
if test "$(cat "$dotest/keep")" = t
then
	keep=-k
fi
J
Junio C Hamano 已提交
248
ws=`cat "$dotest/whitespace"`
249 250 251 252 253 254 255 256 257 258 259 260 261 262
if test "$(cat "$dotest/sign")" = t
then
	SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
			s/>.*/>/
			s/^/Signed-off-by: /'
		`
else
	SIGNOFF=
fi

last=`cat "$dotest/last"`
this=`cat "$dotest/next"`
if test "$skip" = t
then
263
	git rerere clear
264
	this=`expr "$this" + 1`
J
Jan Harkes 已提交
265
	resume=
266 267 268 269 270 271 272 273 274 275 276 277 278 279
fi

if test "$this" -gt "$last"
then
	echo Nothing to do.
	rm -fr "$dotest"
	exit
fi

while test "$this" -le "$last"
do
	msgnum=`printf "%0${prec}d" $this`
	next=`expr "$this" + 1`
	test -f "$dotest/$msgnum" || {
J
Jan Harkes 已提交
280
		resume=
281 282 283
		go_next
		continue
	}
J
Junio C Hamano 已提交
284 285 286 287 288 289 290 291 292

	# If we are not resuming, parse and extract the patch information
	# into separate files:
	#  - info records the authorship and title
	#  - msg is the rest of commit log message
	#  - patch is the patch body.
	#
	# When we are resuming, these files are either already prepared
	# by the user, or the user can tell us to do so by --resolved flag.
293 294
	case "$resume" in
	'')
295
		git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
296 297
			<"$dotest/$msgnum" >"$dotest/info" ||
			stop_here $this
298 299 300 301 302 303

		# skip pine's internal folder data
		grep '^Author: Mail System Internal Data$' \
			<"$dotest"/info >/dev/null &&
			go_next && continue

304
		test -s $dotest/patch || {
305
			echo "Patch is empty.  Was it split wrong?"
306 307
			stop_here $this
		}
308
		git stripspace < "$dotest/msg" > "$dotest/msg-clean"
309 310
		;;
	esac
311 312 313 314

	GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
	GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
	GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
315

316
	if test -z "$GIT_AUTHOR_EMAIL"
317
	then
318
		echo "Patch does not have a valid e-mail address."
319 320 321
		stop_here $this
	fi

J
Junio C Hamano 已提交
322
	export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
323

324
	SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
325
	case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
326 327 328 329 330

	case "$resume" in
	'')
	    if test '' != "$SIGNOFF"
	    then
331
		LAST_SIGNED_OFF_BY=`
332 333 334
		    sed -ne '/^Signed-off-by: /p' \
		    "$dotest/msg-clean" |
		    tail -n 1
335
		`
336 337
		ADD_SIGNOFF=`
		    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
338 339
		    test '' = "$LAST_SIGNED_OFF_BY" && echo
		    echo "$SIGNOFF"
340 341
		}`
	    else
342
		ADD_SIGNOFF=
343 344
	    fi
	    {
345
		printf '%s\n' "$SUBJECT"
346 347 348 349 350 351 352 353 354
		if test -s "$dotest/msg-clean"
		then
			echo
			cat "$dotest/msg-clean"
		fi
		if test '' != "$ADD_SIGNOFF"
		then
			echo "$ADD_SIGNOFF"
		fi
355 356
	    } >"$dotest/final-commit"
	    ;;
J
Junio C Hamano 已提交
357
	*)
358
		case "$resolved$interactive" in
J
Junio C Hamano 已提交
359 360
		tt)
			# This is used only for interactive view option.
361
			git diff-index -p --cached HEAD -- >"$dotest/patch"
J
Junio C Hamano 已提交
362 363
			;;
		esac
364
	esac
365

366
	resume=
367 368
	if test "$interactive" = t
	then
369 370
	    test -t 0 ||
	    die "cannot be interactive without stdin connected to a terminal."
371 372 373 374 375 376 377
	    action=again
	    while test "$action" = again
	    do
		echo "Commit Body is:"
		echo "--------------------------"
		cat "$dotest/final-commit"
		echo "--------------------------"
J
Jason Riedy 已提交
378
		printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
379 380
		read reply
		case "$reply" in
381 382 383
		[yY]*) action=yes ;;
		[aA]*) action=yes interactive= ;;
		[nN]*) action=skip ;;
384
		[eE]*) git_editor "$dotest/final-commit"
J
Junio C Hamano 已提交
385
		       SUBJECT=$(reread_subject "$dotest/final-commit")
386
		       action=again ;;
387 388 389
		[vV]*) action=again
		       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
		*)     action=again ;;
390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407
		esac
	    done
	else
	    action=yes
	fi

	if test $action = skip
	then
		go_next
		continue
	fi

	if test -x "$GIT_DIR"/hooks/applypatch-msg
	then
		"$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
		stop_here $this
	fi

408
	printf 'Applying %s\n' "$SUBJECT"
409

J
Junio C Hamano 已提交
410 411
	case "$resolved" in
	'')
412
		git apply $git_apply_opt $binary --index "$dotest/patch"
J
Junio C Hamano 已提交
413 414 415 416 417 418 419 420
		apply_status=$?
		;;
	t)
		# Resolved means the user did all the hard work, and
		# we do not have to do any patch application.  Just
		# trust what the user has in the index file and the
		# working tree.
		resolved=
421
		git diff-index --quiet --cached HEAD -- && {
422
			echo "No changes - did you forget to use 'git add'?"
423
			stop_here_user_resolve $this
424
		}
425
		unmerged=$(git ls-files -u)
426 427 428
		if test -n "$unmerged"
		then
			echo "You still have unmerged paths in your index"
429
			echo "did you forget to use 'git add'?"
430
			stop_here_user_resolve $this
431
		fi
J
Junio C Hamano 已提交
432
		apply_status=0
433
		git rerere
J
Junio C Hamano 已提交
434 435 436
		;;
	esac

437 438
	if test $apply_status = 1 && test "$threeway" = t
	then
439
		if (fall_back_3way)
440
		then
441 442
		    # Applying the patch to an earlier tree and merging the
		    # result may have produced the same tree as ours.
443
		    git diff-index --quiet --cached HEAD -- && {
444 445 446 447
			echo No changes -- Patch already applied.
			go_next
			continue
		    }
448 449
		    # clear apply_status -- we have successfully merged.
		    apply_status=0
450 451 452 453 454
		fi
	fi
	if test $apply_status != 0
	then
		echo Patch failed at $msgnum.
455
		stop_here_user_resolve $this
456 457 458 459 460 461 462
	fi

	if test -x "$GIT_DIR"/hooks/pre-applypatch
	then
		"$GIT_DIR"/hooks/pre-applypatch || stop_here $this
	fi

463 464 465 466
	tree=$(git write-tree) &&
	parent=$(git rev-parse --verify HEAD) &&
	commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
	git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
467 468 469 470 471 472 473 474 475 476
	stop_here $this

	if test -x "$GIT_DIR"/hooks/post-applypatch
	then
		"$GIT_DIR"/hooks/post-applypatch
	fi

	go_next
done

477 478
git gc --auto

479
rm -fr "$dotest"